// required modules
const SerialPort = require('serialport');
const fs = require('fs');
const csv=require('csv-parser');
const Rx = require('rx');
const mqtt = require('mqtt')
const MongoClient = require('mongodb').MongoClient

//read parameters from parameters.json file
const JSONparameters = fs.readFileSync('./parameters.json');
const parameters = JSON.parse(JSONparameters);

// mongodb connection
const dburl = 'mongodb://localhost:27017/db';
const dbName = 'db'
var collection;
var MongoDBconnect = Rx.Observable.fromNodeCallback(MongoClient.connect);
var MongoDB = MongoDBconnect(dburl);
var subscription = MongoDB.subscribe(
    function (database) {
       collection=database.collection('sensors');
        console.log('MongoDB connected!');
    },
    function (err) {
        console.log('Error: ' + err);   
    },
    function () {
        console.log('Completed');   
    });

// serial connection
const sPort = new SerialPort(parameters.serialport, {
    baudRate: parameters.baudrate,
	autoOpen: false
    })
let myVar = setInterval(function(){ timer() }, 1000);   
function timer(){
sPort.open(function (err) {})
}

try {
    const clientmqtt  = mqtt.connect(parameters.mqtt.url, {username: parameters.mqtt.user , password:parameters.mqtt.password})
    const JSONDataStream = sPort.pipe(csv({headers: parameters.fieldnames, mapValues: ({ value }) => Number(value)}));
    var dataStream = Rx.Observable;
    dataStream 
    .fromEvent(JSONDataStream,'data')
    .map(function(content){
        var time = {Time: new Date()};
        var record = Object.assign({}, time, parameters.description,  content);
        return record;
    })
    .subscribe(function (content)
    {
        collection.insertOne(content)
        clientmqtt.publish('record', JSON.stringify(content), {qos: 1})
        console.log('recorded:', JSON.stringify(content))
    }); 
} catch(err) {
  console.log(err);
  return;
}
